if deductible < plan_deductible then do;
  remaining_deductible = sum(plan_deductible,-deductible);
  deductible + min(remaining_deductible,awp_package_price);
  total_covered_oopc + min(remaining_deductible,awp_package_price);
  remaining_awp_cost = max(0,sum(awp_package_price,-remaining_deductible));
end;
else remaining_awp_cost = awp_package_price;

if remaining_awp_cost > 0 and icl < plan_icl then do;
  remaining_icl = sum(plan_icl,-icl);
  select(SUBSTR(mrx_tier_cstshr_struct_type,1,1));
    when('1') do;
      coins_oopc + min(remaining_awp_cost,awp_package_price * plan_coins);
      total_covered_oopc + min(remaining_awp_cost,awp_package_price * plan_coins);
    end;
    when('2') do;
      copay_oopc + min(remaining_awp_cost,plan_copay);
      total_covered_oopc +  min(remaining_awp_cost,plan_copay);
    end;
    when('3') do;
      coins_amt = min(remaining_awp_cost,awp_package_price * plan_coins);
      copay_amt = min(remaining_awp_cost,plan_copay);
      if coins_amt > copay_amt then do;
        coins_oopc + coins_amt;
        total_covered_oopc + coins_amt;
      end;
      else do;
        copay_oopc + copay_amt;
        total_covered_oopc + copay_amt;
      end;
    end;
    when('4') do;
      coins_amt = min(remaining_awp_cost,awp_package_price * plan_coins);
      copay_amt = min(remaining_awp_cost,plan_copay);
      if coins_amt < copay_amt then do;
        coins_oopc + coins_amt;
        total_covered_oopc + coins_amt;
      end;
      else do;
        copay_oopc + copay_amt;
        total_covered_oopc + copay_amt;
      end;
    end;
    otherwise;
  end;
  remaining_awp_cost = 0;
end;

if remaining_awp_cost > 0 and threshold < plan_threshold then do;
  if drug_type='G' then discount_awp_price=awp_package_price*&GENERIC_GAP_DISCOUNT.;
  else if drug_type='B' then discount_awp_price=awp_package_price*&BRAND_GAP_DISCOUNT.;
  total_covered_oopc + min(discount_awp_price,sum(plan_threshold,-threshold));
  remaining_awp_cost = max(0,sum(discount_awp_price,-sum(plan_threshold,-threshold)));
end;

if remaining_awp_cost > 0 and threshold >= plan_threshold then do;
  if mrx_ae_ooptcs_apply = '1' then do;
    if drug_type = 'G' then do;
      if (remaining_awp_cost < plan_copay_cat_gen) and (remaining_awp_cost <
          (awp_package_price * 0.05)) then do;
        copay_oopc + remaining_awp_cost;
        total_covered_oopc + remaining_awp_cost;
      end;
      else if plan_copay_cat_gen >= (awp_package_price * 0.05) then do;
        copay_oopc + plan_copay_cat_gen;
        total_covered_oopc + plan_copay_cat_gen;
      end;
      else do;
        coins_oopc + (awp_package_price * 0.05);
        total_covered_oopc + (awp_package_price * 0.05);
      end;
    end;
    else if drug_type = 'B' then do;
      if (remaining_awp_cost < plan_copay_cat_brand) and (remaining_awp_cost <
            (awp_package_price * 0.05)) then do;
        copay_oopc + remaining_awp_cost;
        total_covered_oopc + remaining_awp_cost;
      end;
      else if plan_copay_cat_brand >= (awp_package_price * 0.05) then do;
        copay_oopc + plan_copay_cat_brand;
        total_covered_oopc + plan_copay_cat_brand;
      end;
      else do;
        coins_oopc + (awp_package_price * 0.05);
        total_covered_oopc + (awp_package_price * 0.05);
      end;
    end;
  end;
  else do;
    select(SUBSTR(mrx_tier_cstshr_struct_type,2,1));
      when('1') do;
        coins_oopc + min(remaining_awp_cost,awp_package_price * plan_coins_cat);
        total_covered_oopc + min(remaining_awp_cost,awp_package_price * plan_coins_cat);
      end;
      when('2') do;
        copay_oopc + min(remaining_awp_cost,plan_copay_cat);
        total_covered_oopc +  min(remaining_awp_cost,plan_copay_cat);
      end;
      when('3') do;
        coins_amt = min(remaining_awp_cost,awp_package_price * plan_coins_cat);
        copay_amt = min(remaining_awp_cost,plan_copay_cat);
        if coins_amt > copay_amt then do;
          coins_oopc + coins_amt;
          total_covered_oopc + coins_amt;
        end;
        else do;
          copay_oopc + copay_amt;
          total_covered_oopc + copay_amt;
        end;
      end;
      when('4') do;
        coins_amt = min(remaining_awp_cost,awp_package_price * plan_coins_cat);
        copay_amt = min(remaining_awp_cost,plan_copay_cat);
        if coins_amt < copay_amt then do;
          coins_oopc + coins_amt;
          total_covered_oopc + coins_amt;
        end;
        else do;
          copay_oopc + copay_amt;
          total_covered_oopc + copay_amt;
        end;
      end;
      otherwise;
    end;
  end;
end;

if icl < plan_icl then icl + awp_package_price;
threshold + awp_package_price;
